/***************************************************************************
                          mosixview.cpp  -  description
                             -------------------
    begin                : Tue May  8 18:01:05 GMT 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mosixview.h"
#include "widgetmain.h"
#include "fileopen.xpm"


Mosixview::Mosixview()
{
  setCaption("Mosixview " VERSION);
  
  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initMenuBar();
  initToolBar();
  initStatusBar();
  initView();
}

Mosixview::~Mosixview()
{
}


void Mosixview::addWidgets(QApplication *a){
	widgetMain *new_widgets = new widgetMain(this, "Widgets");
	new_widgets->setupQuit(a);
	new_widgets->setGeometry(0,55,670,560);

}


void Mosixview::initMenuBar()
{
  ///////////////////////////////////////////////////////////////////
  // menuBar entry fileMenu

  fileMenu=new QPopupMenu();
  fileMenu->insertItem("&Run prog", this, SLOT(slotFileOpen()), CTRL+Key_O, ID_FILE_OPEN);
  fileMenu->insertSeparator();
  fileMenu->insertItem("E&xit", this, SLOT(slotFileQuit()), CTRL+Key_Q, ID_FILE_QUIT);

  ///////////////////////////////////////////////////////////////////
  // menuBar entry helpMenu
  helpMenu=new QPopupMenu();
  helpMenu->insertItem("About...", this, SLOT(slotHelpAbout()), 0, ID_HELP_ABOUT);



  viewMenu=new QPopupMenu();
  viewMenu->setCheckable(true);
  viewMenu->insertItem("Tool&bar", this, SLOT(slotViewToolBar()), 0, ID_VIEW_TOOLBAR);
//  viewMenu->insertItem("&Statusbar", this, SLOT(slotViewStatusBar()), 0, ID_VIEW_STATUSBAR);

  viewMenu->setItemChecked(ID_VIEW_TOOLBAR, true);
//  viewMenu->setItemChecked(ID_VIEW_STATUSBAR, true);


//  	QPopupMenu *configMenu = new QPopupMenu();

//    configMenu=new QPopupMenu();
//    configMenu->setCheckable(true);
//    configMenu->insertItem("nslookup", this, SLOT(slotViewToolBar()), 0, CTRL+Key_N);
//    configMenu->setItemChecked(CTRL+Key_N, true);


  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  // set menuBar() the current menuBar 

  menuBar()->insertItem("&Run", fileMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem("&View", viewMenu);
  menuBar()->insertSeparator();
//    menuBar()->insertItem("&Config", configMenu);
//    menuBar()->insertSeparator();
  menuBar()->insertItem("&Help", helpMenu);
  
  connect(fileMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(helpMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));

  ///////////////////////////////////////////////////////////////////
  // CONNECT THE SUBMENU SLOTS WITH SIGNALS

  connect(fileMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(viewMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(helpMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));



}

void Mosixview::initToolBar()
{
  QPixmap openIcon, saveIcon, newIcon;

  fileToolbar = new QToolBar(this, "file operations");

//    newIcon = QPixmap(filenew);
//    QToolButton *fileNew = new QToolButton(newIcon, "New File", 0, this,
//                                           SLOT(slotFileNew()), fileToolbar);

  openIcon = QPixmap(fileopen);
  QToolButton *fileOpen = new QToolButton(openIcon, "run prog", 0, this,
                                          SLOT(slotFileOpen()), fileToolbar);




//    saveIcon = QPixmap(filesave);
//    QToolButton *fileSave = new QToolButton(saveIcon, "Save File", 0, this,
//                                            SLOT(slotFileSave()), fileToolbar);


  fileToolbar->addSeparator();
  QWhatsThis::whatsThisButton(fileToolbar);
//    QWhatsThis::add(fileNew,"Click this button to create a new file.\n\n"
//                    "You can also select the New command from the File menu.");
  QWhatsThis::add(fileOpen,"Click this button to open a new programm.\n"
                  "You can also select the run command from the Execute menu.");
//    QWhatsThis::add(fileSave,"Click this button to save the file you are "
//                    "editing. You will be prompted for a file name.\n\n"
//                    "You can also select the Save command from the File menu.");


}






void Mosixview::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  //STATUSBAR
  statusBar()->message(IDS_STATUS_DEFAULT, 2000);
}


void Mosixview::initView()
{ 
  ////////////////////////////////////////////////////////////////////
  // set the main widget here
  view=new MosixviewView(this, doc);
  setCentralWidget(view);
}

bool Mosixview::queryExit()
{
  int exit=QMessageBox::information(this, "Quit...",
                                    "Do your really want to quit?",
                                    QMessageBox::Ok, QMessageBox::Cancel);

  if (exit==1)
  {

  }
  else
  {

  };

  return (exit==1);
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////



void Mosixview::slotFileOpen()
{
  statusBar()->message("executing programm");

  QString fileName = QFileDialog::getOpenFileName(0,0,this);
  if (!fileName.isEmpty())
  {
    doc->load(fileName);
    setCaption(fileName);
    QString message="executed "+fileName;
    statusBar()->message(message, 2000);
  }
  else
  {
    statusBar()->message("execution aborted", 2000);
  }
}



void Mosixview::slotFileQuit()
{ 
  statusBar()->message("Exiting application...");

    if(queryExit())
    {
      qApp->quit();
    }
    else
    {

    };



  statusBar()->message(IDS_STATUS_DEFAULT);
}





void Mosixview::slotViewToolBar()
{
  statusBar()->message("Toggle toolbar...");
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off

  if (fileToolbar->isVisible())
  {
    fileToolbar->hide();
    viewMenu->setItemChecked(ID_VIEW_TOOLBAR, false);
  }
  else
  {
    fileToolbar->show();
    viewMenu->setItemChecked(ID_VIEW_TOOLBAR, true);
  };

  statusBar()->message(IDS_STATUS_DEFAULT);
}





void Mosixview::slotViewStatusBar()
{
  statusBar()->message("Toggle statusbar...");
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off

  if (statusBar()->isVisible())
  {
    statusBar()->hide();
    viewMenu->setItemChecked(ID_VIEW_STATUSBAR, false);
  }
  else
  {
    statusBar()->show();
    viewMenu->setItemChecked(ID_VIEW_STATUSBAR, true);
  }

  statusBar()->message(IDS_STATUS_DEFAULT);
}





void Mosixview::slotHelpAbout()
{
  QMessageBox::about(this,"About...",
                     IDS_APP_ABOUT );
}

void Mosixview::slotStatusHelpMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message of whole statusbar temporary (text, msec)
  statusBar()->message(text, 2000);
}

void Mosixview::statusCallback(int id_)
{
  switch (id_)
  {

    case ID_FILE_OPEN:
         slotStatusHelpMsg("Run programm");
         break;

    case ID_FILE_QUIT:
         slotStatusHelpMsg("Quits the application");
         break;


    case ID_HELP_ABOUT:
         slotStatusHelpMsg("Shows an aboutbox");
         break;
  }
}



